<template>
  <div class="add-event">
    <div class="add-event__top">
      <div class="form-block">
        <div class="form-block__title">Name</div>
        <div class="form-block__content">
          <el-input
            v-model="newItem.name"
            border
            line
            placeholder="Cool name only!"
          />
        </div>
      </div>
      <div class="form-block">
        <div class="form-block__title">Category</div>
        <div class="form-block__content">
          <el-select
            v-model="newItem.category"
            border
            line
            placeholder="Category"
          >
            <el-option value="Photography">Photography</el-option>
            <el-option value="Paintings">Paintings</el-option>
            <el-option value="Music">Music</el-option>
            <el-option value="Food">Food</el-option>
            <el-option value="Jewelery">Jewelery</el-option>
            <el-option value="Furniture">Furniture</el-option>
          </el-select>
        </div>
      </div>
      <div class="form-block flex">
        <div class="form-block__value">
          <div class="form-block__title">Duration</div>
          <div class="form-block__content flex">
            <div>{{ newItem.duration }} hour</div>
          </div>
        </div>
        <div class="form-block__buttons">
          <button
            class="form-block__btn"
            @click="newItem.duration > 1 ? newItem.duration-- : false"
            v-wave
          >
            –
          </button>
          <button class="form-block__btn" @click="newItem.duration++" v-wave>
            +
          </button>
        </div>
      </div>
      <div class="form-block">
        <div class="form-block__title">Location near by</div>
        <div class="form-block__content">
          <el-input value="1" placeholder="Cool name only!" />
        </div>
      </div>
      <div class="form-block">
        <div class="form-block__title">Available dates</div>
        <div class="form-block__content">
          <el-input value="1" placeholder="Cool name only!" />
        </div>
      </div>
      <div class="form-block flex">
        <div class="form-block__value">
          <div class="form-block__title">Price</div>
          <div class="form-block__content">
            <el-input v-model="newItem.price" />
          </div>
        </div>
        <div class="form-block__price">
          <el-select
            v-model="newItem.payment_currency"
            border
            line
            :popper-append-to-body="false"
          >
            <el-option value="$">
              <div>$ – US Dollar</div>
            </el-option>
            <el-option value="🙏" disabled>
              <div>Donation</div>
              <span class="select-soon">soon</span>
            </el-option>
            <el-option value="€" disabled>
              <div>€ – European Euro</div>
              <span class="select-soon">soon</span>
            </el-option>
            <el-option value="₽" disabled>
              <div>₽ – Russian Ruble</div>
              <span class="select-soon">soon</span>
            </el-option>
            <el-option value="₹" disabled>
              <div>₹ – Brazil Real</div>
              <span class="select-soon">soon</span>
            </el-option>
            <el-option value="¥" disabled>
              <div>¥ – China Yen</div>
              <span class="select-soon">soon</span>
            </el-option>
          </el-select>
        </div>
      </div>
      <div class="form-block">
        <div class="form-block__title">Description</div>
        <div class="form-block__content">
          <el-input
            type="textarea"
            v-model="newItem.description"
            :rows="2"
            placeholder="Please input"
            border
            line
          >
          </el-input>
        </div>
      </div>
      <el-upload type="preview" />
    </div>
    <div class="add-event__buttons">
      <div><Button @click="createStore">Launch</Button></div>
      <div><Button @click="$emit('close')" variant="grey">Close</Button></div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from '@nuxtjs/composition-api'
import { useCreateStoreMutation } from '~/sdk/hooks'
import useGenerateUUID from '@/hooks/generate-uuid'

import elCheckbox from '@/components/element/Checkbox.vue'
import elInput from '@/components/element/Input.vue'
import elSelect from '@/components/element/Select.vue'
import elUpload from '@/components/element/Upload.vue'
import elTag from '@/components/element/Tag.vue'

import Button from '@/components/ui/Button.vue'

type Item = {
  id: string
  name: string
  description: string
  category: string
  type: string
  duration: number
  location: string
  nft: boolean
  price: number
  payment_currency: string
}

export default defineComponent({
  name: 'AddEventStore',
  components: {
    Button,
    elTag,
    elUpload,
    elInput,
    elSelect,
    elCheckbox
  },
  setup(_, { root }) {
    const newItem = ref<Item>(createItem())
    function createItem(): Item {
      const object: Item = {
        id: useGenerateUUID(),
        name: '',
        description: '',
        category: '',
        type: 'EVENT',
        duration: 1,
        location: '',
        nft: false,
        price: 0,
        payment_currency: '$'
      }
      return object
    }

    const { mutate: createStoreMutation } = useCreateStoreMutation({})
    async function createStore() {
      await createStoreMutation({
        object: {
          id: newItem.value.id,
          name: newItem.value.name,
          description: newItem.value.description,
          type: newItem.value.type as any,
          category: newItem.value.category as any,
          duration: newItem.value.duration,
          price: newItem.value.price,
          currency: 'USDN'
          // location_id: newItem.value.location,
          // nft: newItem.value.nft
        }
      })
      // succes.value = true
    }

    return { newItem, createStore }
  }
})
</script>
